<script setup lang="ts">
  const props = defineProps<{
    controller: ReturnType<typeof useModal>;
  }>();

  const { hideTokenPermissionsRequest, stateForMe } = usePresentationState();
  const { updateAttendeeData } = useUser();
  const { mercurePublish } = useMercure();

  const accept = () => {
    updateAttendeeData({ guideCartPermissionsGranted: true });
    mercurePublish.client(MercureEvent.GRANTED_TOKEN_PERMISSION, stateForMe?.value?.attendeeId);
    props.controller.close();
  };

  const close = () => {
    hideTokenPermissionsRequest();
    props.controller.close();
  };
</script>

<template>
  <SwModal :controller="controller">
    <template #body>
      <p class="text-information-dark text-lg font-bold">
        {{ $t('presentation.permissionRequested') }}
      </p>
      <p class="text-information mt-2 text-sm">
        {{ $t('presentation.requestPermissionMessage') }}
      </p>
    </template>

    <template #footer>
      <SwButton variant="action" @click="close">{{ $t('decline') }}</SwButton>
      <SwButton variant="primary" @click="accept">{{ $t('accept') }}</SwButton>
    </template>
  </SwModal>
</template>
